require "java"

include_class ["javax.swing.JFrame", "javax.swing.JTable",
               "jrubysupport.DefaultTableModelShim", "jrubysupport.DefaultTableModelDelegate"] 

class PascalTableModel< DefaultTableModelDelegate
	def getColumnCount()
		10
	end

	def getRowCount()
		10
	end

	def getValueAt(row, column)
		if column == 0 or column == row
			1
		elsif column < row
			getValueAt(row - 1, column) + getValueAt(row - 1, column-1)
		end
	end
end
 
model = DefaultTableModelShim.new(PascalTableModel.new)
jtable = JTable.new(model)
jframe = JFrame.new("Pascal's Triangle")
jframe.getContentPane().add(jtable)
jframe.setDefaultCloseOperation(JFrame::EXIT_ON_CLOSE)
jframe.pack()
jframe.setVisible(true)
