# This is a skeletal class definition for a character in the online
# game "Hamster Wars". In a production scenario, more business 
# logic would be defined in this class; alternatively approach, 
# we could make do without this class definition, 
# generating the class on-the-fly from the XML (in this example, we do just
# that for the target class in transform.rb).
module HamsterWars
	class HamsterCharacter
		# The following lines dynamically define the given attributes 
		# and give them "getters" and "setters"
		attr_accessor :customer_first_name, :customer_last_name, 
			    :character_alias, :experience, :balance_dollars, :hits    
 	end
end
